        org  57088+768       ;=57856 -> 61000 = 3144

CODE_START:
        defw Bdata,PAINT,SETUP,FALLING,SPIDERS, CODE_FINISH - CODE_START
        defw CODE_FINISH,MCTRAP,EXPLOSION,ROBOTS,LOADT1_2,SCAN_USR,UNSTABLE
;Erase the map by repeatedly printing vertical bars across the screen
;with INK colours changing from white through to black on black PAPER.
;Square (1,1) is set to White, then row 1 copied to rows 2-18, giving
;one white column. Then square (1,2) is set to White and the rows
;copied again, giving two white columns. Repeated up to square (1,30).
;Then all repeated for each remaining INK colour from Yellow to Black.
PAINT:  ld   a,8
P0:     ex   af,af'
        ld   bc,10           ;10/50ths second
        call $1F3D           ;PAUSE_1 (uses A & BC)
        ex   af,af'
        push af
        dec  a               ;A =INK
        ld   hl,22561        ;row 1, col 1
        ld   b,30            ;30 chars
P1:     push bc
        ld   de,22561        ;row 1, col 1
        ld   (23680),de
        ld   (hl),a          ;set attribute for char (hl) in row 1
        push hl
        ld   b,17            ;17 rows to copy down from row 1
P3:     push bc
        ld   bc,32
        ld   hl,(23680)      ;current row start
        add  hl,bc           ;+32
        ld   (23680),hl      ;=next row start
        ld   de,22561        ;source row start
        ex   de,hl           ;swap source/destination
        ld   bc,30
        ldir                 ;copy down 30 chars from row 1
        pop  bc              ;B =rows remaining to copy down from row 1
        djnz P3
        pop  hl
        inc  hl              ;next char to set on row 1
        pop  bc              ;B =chars remaining to set on row 1
        djnz P1
        pop  af
        dec  a               ;current INK
        jp   nz,P0
        ret

;display file addressing bit patterns (using the HL register pair):
;H =010ssppp, ss=segment 0-2, ppp=pixline 0-7;
;L =rrrccccc, rrr=char.row 0-7, ccccc=char.col 0-31

;The screen is divided into 3 segments numbered 0-2 (bits ss in H);
;each segment has 8 rows of characters numbered 0-7 (bits rrr in L);
;each row of characters has 8 lines of pixels numbered 0-7 (bits ppp in H);
;each line of pixels has 32 column bytes numbered 0-31 (bits ccccc in L).

;To move along the columns, increment L. This will automatically calculate the
;correct address for the next row and reset the column when ccccc carries over
;from 31. When rrr carries over from 7 then update segment ss by adding 8 to H.
;To move down the rows add 32 to L.
;To move down the segments add 8 to H.
;To move down the pixlines within a row, increment H. This will automatically
;calculate the correct address for the corresponding row in the next segment and
;reset the pixline when ppp carries over from 7.

;Hence row 1,1 = 01000000 00100001 = $4021
;         18,1 = 01010000 01000001 = $5041


;8010 RANDOMIZE 44000+300*le: LET s=USR 57918:
;     LET x=PEEK 23681: LET y=PEEK 23680: LET z$=CHR$ 22+CHR$ x+CHR$ y

;8010 LET s=44000+300*le: LET a=k0: LET b=k0:
;     LET p$=CHR$ 16+CHR$ 2+CHR$ 17+CHR$ 6+CHR$ 47
SETUP:
;8010 LET s=44000+300*le: LET a=k0: LET b=k0:
        ld   hl,64000      ;!
        ld   (hl),$FF      ;*
        ld   de,64001      ;!
        ld   bc,847        ;*
        ldir               ;*;reset FALLING table
        ld   bc,8            ;A =length of variable header
        ld   de,Sdollar      ;BC=address of variable name
        call FindVariable    ;HL=start address of Sdata
        ld   (Sdata),hl
        ld   c,0             ;B=a=row, C=b=col
        ld   hl,(23670)      ;HL=start address of level data in RAM
;8020 LET t=PEEK s:
;     IF a>18 THEN GO TO 9000
S8020:  ld   a,b             ;A =row
        cp   19              ;check if at end of map
        ret  nc              ;SETUP exit point #1 of 2
        ld   a,(hl)          ;A =next byte of level data
;8021 IF t=255 THEN
;       LET b=b+PEEK (s+1): LET s=s+2:
;       IF b>31 THEN
;         LET a=a+1+INT ((b-32)/32): LET b=b-INT (b/32)*32
        cp   255
        jp   nz,S8023        ;if byte=$FF then ...
        ld   a,c
        inc  hl
        add  a,(hl)          ;... next byte is a column update value
        ld   c,a             ;update column
        inc  hl              ;both that byte & the next byte are skipped
        cp   32
        jp   c,S8020         ;column overflow?
        sub  32              ;if so ...
        and  %11100000
        rlca
        rlca
        rlca
        inc  a
        add  a,b
        ld   b,a             ;... B =new row, and ...
        ld   a,c
        and  %11100000
        sub  c
        neg
        ld   c,a             ;... C =new col
;8022 IF t=255 THEN
;       GO TO 8020
        jp   S8020
;8023 IF t=47 THEN
;       PRINT AT a,b;p$: LET s=s+1: LET t=PEEK s
S8023:  cp   47
        jp   nz,S8024        ;is it a wall byte?
        ld   a,b
        ld   (WALLROW),a
        ld   a,c
        ld   (WALLCOL),a
        push bc
        ld   de,WALLAT
        ld   bc,8
        call $203C           ;PR_STRING, print wall character ...
        pop  bc
        inc  hl
        ld   a,(hl)          ;... and get next byte of level data

;8024 IF t>47 THEN
;       LET s$(t-47)=CHR$ 22+CHR$ a+CHR$ b: LET s=s+1:
;       IF t=61 THEN LET x=a: LET y=b: LET z$=CHR$ 22+CHR$ x+CHR$ y
S8024:  cp   48
        jp   c,S8025         ;if =47 (wall), jump
        cp   61
        jp   c,S8024b        ;if <61 (key,door,spider), jump
        jp   nz,Sbang        ;if not Digger's CHR$ (61), jump
        ld   (23680),bc      ;... position to (23680)=C=y=col, (23681)=B=x=row
        add  a,6             ;skip 6 rows reserved for robot->spider
S8024b: push af
        push hl
        sub  48              ;offsets start at zero
        ld   e,a
        add  a,e
        ld   (Tab1off),a
        add  a,e
        ld   hl,(Sdata)      ;save object's starting position in s$()
        ld   d,0
        ld   e,a
        add  hl,de
        ld   (hl),$16        ;AT control
        inc  hl
        ld   (hl),b          ;row
        inc  hl
        ld   (hl),c          ;col
        call RowColBCDispHL
        push bc            ;*
        push hl            ;*
        call GetAttrAddr   ;*
        ld   de,64240-22528;!;offset attribute pointer into Table2
        add  hl,de         ;*
        ld   a,(Tab1off)   ;*
        add  a,200
        ld   (hl),a        ;*;save Table1 offset in Table2
        ld   hl,64000      ;!;Table1 start address
        ld   b,0
        ld   c,a
        add  hl,bc         ;*
        pop  de            ;*
        ld   (hl),e        ;*
        inc  hl            ;*
        ld   (hl),d        ;*;save display file address in Table1
        pop  bc            ;*

S8024c: pop  hl
        inc  hl
        pop  af
;8025 IF t THEN
;       LET b=b+1: LET s=s+1:
;       IF b>31 THEN
;         LET a=a+1: LET b=0
S8025:  or   a               ;zero byte = end of level data
        ret  z               ;SETUP exit point #2 of 2
        inc  c               ;otherwise, update RAM pointer & row,col
        inc  hl
        ld   a,c
        cp   32
        jp   c,S8020
        inc  b
        ld   c,0
;8026 IF t THEN
;       GO TO 8020
        jp   S8020           ;loop back for next byte

Sbang:  push af              ;if an explosive,
        push hl              ;save object's starting position in (Bdata)
        sub  62
        sla  a
        ld   hl,Bdata
        ld   d,0
        ld   e,a
        add  hl,de
        ld   (hl),b          ;row
        inc  hl
        ld   (hl),c          ;col
        jp   S8024c          ;jump back for next byte

RowColBCDispHL:
        ld   a,b           ;*;convert row,col in B,C to...
        and  %00011000     ;*
        or   %01000000     ;*
        ld   h,a           ;*
        ld   a,b           ;*
        rrca               ;*
        rrca               ;*
        rrca               ;*
        and  %11100000     ;*
        add  a,c           ;*
        ld   l,a           ;*;...display file address in HL
        ret


WALLAT: defb $16             ;AT control
WALLROW:defb 0
WALLCOL:defb 0
WALL:   defb $10,$02,$11,$06,$2F  ;INK 2, PAPER 6, "/" (wall)
Sdollar:defm "s$():"
Sdata:  defw 0000            ;start address of s$() data
Tab1off:defw 0000          ;*;Table1 offset (range 200-238, step 2, hi-byte 0)
Bdata:  defs 20

FindVariable:
        push bc
        ld   bc,(23645)      ;(CH_ADD)
        push bc
        ld   (23645),de      ;DE=location of variable name
        call $28B2           ;LOOK_VARS
        pop  bc
        ld   (23645),bc
        pop  bc
        jp   c,$0670         ;"2 - Variable not found"
        add  hl,bc           ;skip over header
        ret

                             ;display file addresses:
HereD:  defw 0000            ;current square
BeloD:  defw 0000            ;square below current square
ThereD: defw 0000            ;move HereD to ThereD
                             ;attribute addresses:
HereA:  defw 0000            ;current square
BeloA:  defw 0000            ;square below current square
ThereA: defw 0000            ;move HereA to ThereA

Ther0D: defw 0000
Ther0A: defw 0000
Ther1D: defw 0000
Ther1A: defw 0000

                             ;identifying attributes:
Moving_Types: defb 64+5, 2, 64+3,64+4,    64+6,64+7; diamond,rock,keys   ;#
Moving_Items: defw 6                ;key3 has same attributes as diamond ;#

        ;  scan rows 18->2 for sliding objects
        ;& make any unstable objects slide into the spaces

        ;   A  free rock  ... or ...  rock free
        ;          /                      \
        ;   B  free rock              rock free

        ;A.rock will fall to B.free in either situation.
        ;SLIDING moves A.rock to A.free; then
        ;FALLING moves A.rock to B.free.

FALLING:;  scan rows 18->2 for empty squares
        ;& make any unsupported objects fall into the spaces
        ;& make any unstable objects slide into the spaces
        di
        exx
        push hl
        ld   ix,64000      ;!
        ld   b,105         ;*rocks,diamonds,keys
        xor  a
        ld   (23681),a       ;reset falling objects flag
fColumnNext:               ;*
        ld   l,(ix+0)      ;*
        ld   h,(ix+1)      ;*;display file address
        ld   a,h           ;*
        or   l             ;*
        jp   z,fNextB      ;*

        ld   a,h             ;convert display file address HL ...
        rrca
        rrca
        rrca
        and  %00000111
        or   %01011000
        ld   d,a
        ld   e,l             ;...to attribute file address DE

        ld   (HereD),hl
        ld   (HereA),de
        ld   a,l
        add  a,32
        ld   l,a
        jp   nc,SquareBelow
        ld   a,h
        add  a,8
        ld   h,a
SquareBelow:
        push bc            ;*
        ;FALLING
        ld   (BeloD),hl    ;*;save this column's address
        ex   de,hl
        ld   bc,32
        add  hl,bc
        ex   de,hl
        ld   (BeloA),de    ;*;save attribute address
        call CheckEmpty    ;*
        jp   nz,sColumnNext
fRightType:;move Here to There and CHR$ space to Here
        ld   (ThereD),hl
        ld   (ThereA),de
        jp   ModeS

sColumnNext:;SLIDING
        cp   3
        jp   z,SetFalling
        cp   5
        jp   nz,CheckSliding
SetFalling:
        ld   (23681),a
CheckSliding:
        call CheckMoving     ;check square below current square
        jp   nz,fNextSquare
        dec  hl
        dec  de
        call CheckEmpty      ;check to left of Below
        jp   z,CheckAboveLeft
CheckBelowRight:
        ld   hl,(BeloD)
        ld   de,(BeloA)
        inc  hl
        inc  de
        call CheckEmpty      ;check to right of Below
        jp   nz,fNextSquare
CheckAboveRight:
        ld   (Ther1D),hl     ;save BelowRight if mode=1
        ld   (Ther1A),de     ;                       "
        ld   hl,(HereD)
        ld   de,(HereA)
        inc  hl
        inc  de
        call CheckEmpty      ;check to right of Here
        jp   nz,fNextSquare
        ld   (Ther0D),hl     ;save AboveRight if mode=0
        ld   (Ther0A),de     ;                       "
        jp   MoveIt

CheckAboveLeft:
        ld   (Ther1D),hl     ;save BelowLeft if mode=1
        ld   (Ther1A),de     ;                      "
        ld   hl,(HereD)
        ld   de,(HereA)
        dec  hl
        dec  de
        call CheckEmpty      ;check to left of Here
        jp   nz,CheckBelowRight
        ld   (Ther0D),hl     ;save AboveLeft if mode=0
        ld   (Ther0A),de     ;                      "

MoveIt: ;move Here object to There
        ld   a,(PLAY_MODE)
        or   a
        jp   nz,Mode1
Mode0:  ld   bc,(Ther0D)
        ld   (ThereD),bc
        ld   bc,(Ther0A)
        ld   (ThereA),bc
        jp   ModeS
Mode1:  ld   bc,(Ther1D)
        ld   (ThereD),bc
        ld   bc,(Ther1A)
        ld   (ThereA),bc

ModeS:  inc  a
        ld   (23681),a       ;set falling objects flag
        ld   hl,(HereA)      ;old attr.addr
        ld   a,(hl)          ;get attributes
        ld   (hl),0          ;set old square to black PAPER, black INK
        ld   hl,(ThereA)     ;new attr.addr
        ld   (hl),a          ;copy attributes to new square

        ld   hl,(HereA)      ;old attr.addr
        ld   bc,64240-22528;!;offset for old attribute pointer into Table2
        add  hl,bc         ;*;old attr.addr + BC = old Table2 addr
        ld   a,(hl)        ;*;copy offset in Table1 from old position
        ld   (hl),$FF      ;*;clear from old position
        ld   hl,(ThereA)     ;new attr.addr
        ld   bc,64240-22528;!;offset for new attribute pointer into Table2
        add  hl,bc         ;*;new attr.addr + BC = new Table2 addr
        ld   (hl),a        ;*;copy offset in Table1 to new position

        ld   hl,(HereD)
        ld   de,(ThereD)
        ld   b,8
        ld   (ix+0),e      ;*
        ld   (ix+1),d      ;*
MoveAll:ld   a,(hl)          ;copy CHR$ form to new square, clear old square
        ld   (de),a
        ld   (hl),0
        inc  h
        inc  d
        djnz MoveAll

fNextSquare:;check next square
        pop  bc
fNextB: inc  ix            ;*
        inc  ix            ;*
        dec  b
        jp   nz,fColumnNext
        pop  hl
        exx
        ei
        ld   a,(23681)
        ld   b,0
        ld   c,a             ;return falling objects flag
        ret

CheckEmpty:;check if square starting at HL is empty
        ld   a,(PLAY_MODE)   ;A =mode 0 or 1
        add  a,6
        ld   c,a             ;C =alternative attribute (if not 0)
        ld   a,(de)          ;A =attribute code
        or   a
        ret  z               ;return if 0 (empty BLACK square), Zero set
        cp   c
        ret  nz              ;return if not alternative either, Zero reset
        push hl
        exx
        pop  de              ;DE=display address
        ld   bc,32*8         ;BC=offset for " "
        ld   hl,(23606)      ;(CHARS)
        add  hl,bc
        ld   b,8
CheckAT:ld   a,(de)
        cp   (hl)
        jp   nz,CheckEX      ;bitmap doesn't match, Zero reset
        inc  d
        inc  hl
        djnz CheckAT
        xor  a               ;both attribute & bitmap match, set Zero
CheckEX:exx
        ret

        ;check square's attributes against types
CheckMoving:
        push hl
        ld   hl,Moving_Types
        ld   bc,(Moving_Items)
        ld   a,(de)
        cpir
        pop  hl
        ret


;            row,column displacements
;  20 DATA   j1-1,j2, j1,j2+1, j1+1,j2, j1,j2-1
D20:    defb $ff,$00, $00,$01, $01,$00, $00,$ff
;  21 DATA   j1-1,j2-1, j1-2,j2, j1-1,j2+1
D21:    defb $ff,$ff,   $fe,$00, $ff,$01
;  22 DATA   j1-1,j2+1, j1,j2+2, j1+1,j2+1
D22:    defb $ff,$01,   $00,$02, $01,$01
;  23 DATA   j1+1,j2+1, j1+2,j2, j1+1,j2-1
D23:    defb $01,$01,   $02,$00, $01,$ff
;  24 DATA   j1+1,j2-1, j1,j2-2, j1-1,j2-1
D24:    defb $01,$ff,   $00,$fe, $ff,$ff

Distance: defb 0
                         ;all coords are lo.col,hi.row (opposite to BASIC)
P_coords: defw 0000      ;Digger coordinates
O_coords: defw 0000      ;old spider coordinates
N_coords: defw 0000      ;new spider coordinates
N1coords: defw 0000      ;selected spider coordinates
Zdollar:  defm "z$():"
J1:       defm "j1:"
J1AT:     defw 0000
J2:       defm "j2:"
J2AT:     defw 0000
JVALUE:   defb $00,$00,$ff,$00,$00     ;$ff replaced with smallint value

SPIDERS:
        call FindDigger
        ld   bc,1
        ld   de,J1
        call FindVariable
        ld   (J1AT),hl
        ld   de,J2
        call FindVariable
        ld   (J2AT),hl

        ld   ix,(23653)      ;IX=(STKEND)
        ld   h,(ix-03)
        ld   l,(ix-04)       ;HL=address of old spider coords
        inc  hl              ;skip CHR$ 22
        ld   a,(hl)
        ld   (O_coords+1),a  ;spider row
        ld   b,a
        inc  hl
        ld   a,(hl)
        ld   (O_coords),a    ;spider column
        ld   c,a           ;*
        call GetAttrAddr
        and  a
        ld   de,32
        sbc  hl,de
        ex   de,hl
        call CheckMoving     ;check for object Above
        jp   nz,DoChecks

        ld   bc,$FFFF
        call LETJ12
        ret                  ;squashed

FindDigger:
        ld   bc,6
        ld   de,Zdollar
        call FindVariable
        inc  hl
        ld   b,(hl)          ;B =row
        inc  hl
        ld   c,(hl)          ;C =col
        ld   (P_coords),bc   ;Digger coordinates
        ret

LETJ12: ;assign values to J1 & J2
        push bc
        ld   a,b
        ld   (JVALUE+2),a
        ld   hl,JVALUE
        ld   de,(J1AT)
        ld   bc,5
        ldir
        pop  bc
        ld   a,c
        ld   (JVALUE+2),a
        ld   hl,JVALUE
        ld   de,(J2AT)
        ld   bc,5
        ldir
        ret

;  30 RESTORE 20: LET j1=CODE s$(j,2): LET j2=CODE s$(j,3): LET jp=704:
;     POKE 23680,0: POKE 23681,0
;  32 FOR k=1 TO 4: READ xm,ym: LET dt=FN p(23639): LET l=0:
;       IF ATTR (xm,ym)=5 OR ATTR(xm,ym)=7 THEN
;         RESTORE 20+k:
;         FOR l=1 TO 3: READ xn,yn:
;           IF ATTR (xn,yn)=5 OR ATTR(xn,yn)=7 THEN
;             LET dp=ABS (x-xn)+ABS (y-yn):
;             IF dp<jp THEN
;               LET jp=dp: LET xk=xm: LET yk=ym
;  34     IF l THEN NEXT l
;  36   RANDOMIZE dt: POKE 23639,PEEK 23670: POKE 23640,PEEK 23671:
;     NEXT k
;  38 IF jp<704 THEN
;       POKE 23680,yk: POKE 23681,xk
;  40 RETURN

DoChecks:;check for possible spider moves
        di
        ld   bc,$0000
        call LETJ12
        ld   bc,(O_coords)
        call CalcDistance
        ld   (Distance),a    ;=jp

        xor  a
        ld   ix,D20
ForK:
        push af
        push ix
        ex   af,af'
        call GetAttribute
        jp   z,FoundSpace1
NextK:
        pop  ix
        inc  ix
        inc  ix
        pop  af
        add  a,6
        cp   24
        jp   nz,ForK
EndMove:
        ei
        ret

Caught:
        ld   (Distance),a
        call LETJ12
        ld   a,18
        jp   NextK

        ;found available adjacent square in 1st circle,
        ;now check if caught, else the squares adjacent to that one
FoundSpace1:
        call CheckDistance
        ld   (N1coords),bc
        or   a
        jp   z,Caught
        ex   af,af'
        ld   ix,D21
        ld   d,0
        ld   e,a
        add  ix,de
        xor  a
ForL:
        push af
        call GetAttribute
        jp   z,FoundSpace2
NextL:
        inc  ix
        inc  ix
        pop  af
        add  a,6
        cp   18
        jp   nz,ForL
        jp   NextK

        ;found available adjacent square in 2nd circle,
        ;now check the distance from there to Digger
        ;and compare with the current shortest distance
FoundSpace2:
        call CheckDistance
        jp   z,SelectSquare
        jp   nc,NextL

SelectSquare:
        ld   (Distance),a
        ld   bc,(N1coords)
        call LETJ12
        jp   NextL

GetAttribute:
        ld   a,(O_coords)
        add  a,(ix+1)        ;=ym,col offset (or yn)
        ld   c,a           ;*
        ld   (N_coords),a
        ld   a,(O_coords+1)
        add  a,(ix+0)        ;=xm,row offset (or xn)
        ld   b,a
        ld   (N_coords+1),a
        push bc
        call GetAttrAddr     ;calculate attribute address for row B,col C
        pop  bc
        ld   a,(hl)
        cp   0             ;*;empty space ...
        ret  z             ;*;... is OK
        cp   5             ;*;Digger attribute
        jp   z,DoDoors     ;*
        cp   6             ;*;Path attribute
        jp   z,DoDoors     ;*
        cp   7             ;*;Debris attribute
        ret  nz            ;*
        ;FLASH 0, BRIGHT 0, black PAPER, cyan OR yellow INK
        ;check SCREEN$ for doors $37->$3B
DoDoors:call Scrn_BC       ;*;A =SCREEN$ (B,C)
        cp   $37           ;*
        jp   c,NotAdoor    ;*;if < $37
        cp   $3C           ;*
        jp   nc,NotAdoor   ;*;if > $3B
        ret                ;*;Zero reset, Carry set
NotAdoor:                  ;*
        cp   a             ;*
        ret                ;*;Zero set, Carry reset

GetAttrAddr:;calculate attribute address for row B,col C
        ld   e,c           ;*
        xor  a
        ld   d,a             ;DE=col
        srl  b
        rr   a
        srl  b
        rr   a
        srl  b
        rr   a
        ld   c,a             ;BC=row*32
        ld   hl,22528
        add  hl,bc
        add  hl,de           ;HL=22528 + row*32 + col = attribute address
        ret

CheckDistance:
        ld   bc,(N_coords)
        ld   a,(Distance)
        ld   d,a
        call CalcDistance
        cp   d
        ret

CalcDistance:
        ld   a,(P_coords)    ;Digger col
        sub  c               ;spider col
        jp   nc,Calc1
        neg
Calc1:  ld   e,a
        ld   a,(P_coords+1)  ;Digger row
        sub  b               ;spider row
        jp   nc,Calc2
        neg
Calc2:  add  a,e             ;A =distance in squares
        ret                  ;  =half the enclosing rectangle's border


MCTRAP: di
        dec  sp
        dec  sp              ;preserve error return on stack
        ei
MODE48: ld   hl,$1b9e        ;LINE-NEW
        bit  4,(iy+$01)
        jp   z,MCCONT
        ld   a,(19)
        inc  a               ;A =168 if +2A/+3 else 0
        ld   d,a
        ld   a,(5440)        ;A =83 if Sinclair else 65 if Amstrad
        add  a,d             ;A =83 +128k; =65 +2; =233 +2A/+3/+3e
        cp   233
        jp   nz,MCCONT
PLUS3M: ld   hl,$1031        ;STMT-RET (+2A/+3/+3e ROM.1)
        push hl
        ld   hl,$5b2f        ;REGNUOY  (+2A/+3/+3e paging)
MCCONT: push hl
        LD   HL,(23621)      ;save PPC current line
        LD   (16384),HL
        LD   A,(23623)       ;save SUBPPC current statement
        LD   (16386),A
        LD   A,(23610)       ;save ERR_NR error code
        LD   (16387),A
        LD   A,$ff
        LD   (23610),A       ;reset error code
        LD   HL,6000         ;line number of BASIC error handler
        ld   a,1             ;statement number
        ld   d,a
MCLOOP: CALL $1f54           ;BREAK-KEY
        JP   C,$1e73         ;GO-TO-2 - jump if not BREAK
        JR   MCLOOP          ;ignore BREAK



EXPLOSION:;build the explosion overlay n$(), put " " in preserved squares
          ;build the clean-up string j$() to restore the preserved CHR$
          ;(clean-up not needed for mode 1)
          ;record preserved CHR$ atttributes in d$()
Get_s4_dS:
        di
        ld   bc,1
        ld   de,VAR_su
        call Get_s4          ;get su } vertical range
        call Get_s4          ;get sv }
        call Get_s4          ;get sg } horizontal range
        call Get_s4          ;get sh }
        ld   ix,VAL_su
        ld   (ix+15),0       ;s=0
Get_dS:
        ld   bc,8
        ld   de,VAR_dS
        call FindVariable    ;d$()
        ld   (ADDRdS),hl
        ld   bc,3
        ld   de,VAR_qS
        call FindVariable    ;q$()
        ld   (ADDRqS),hl
        ld   de,VAR_oS
        call FindVariable    ;o$()
        ld   (ADDRoS),hl
        ld   bc,6
        ld   de,VAR_nS
        call FindVariable    ;n$()
        ld   (ADDRnS),hl
        ld   de,VAR_jS
        call FindVariable    ;j$()
        ld   (ADDRjS),hl

        ld   a,(ix+12)
        sub  (ix+8)
        inc  a
        ld   (COLS),a        ;cols=sh-sg+1

        exx                  ;switch to alternate
        ld   b,(ix+0)        ;su = v
        ld   c,(ix+4)        ;sv
        ld   e,(ix+12)       ;sh
FOR_v2:
        ld   a,b
        exx                  ;switch to primary

        ld   (VAL_lS+1),a    ;calculate LH attribute address from row
        rrca
        rrca
        rrca
        ld   l,a
        and  %00000111
        ld   h,a
        ld   a,l
        and  %11100000
        ld   l,a
        ld   bc,22528
        add  hl,bc
        ld   (VAL_va),hl     ;va=22528+32*v
        ld   a,(ix+8)
        ld   (VAL_lS+2),a    ;l$=CHR$ 22+CHR$ v+CHR$ sg

        ld   de,(ADDRnS)
        ld   hl,VAL_lS
        ld   bc,3
        ldir                 ;LH row,col
        ld   (ADDRnso),de
        ld   hl,(ADDRqS)
        ld   bc,(COLS)
        ldir                 ;copy a row of "0" to n$()
        ld   (ADDRnS),de     ;LET n$(snf TO )=l$+q$

        ld   de,(ADDRjS)
        ld   hl,VAL_lS
        ld   bc,3
        ldir                 ;LH row,col
        ld   (ADDRjso),de
        ld   hl,(ADDRoS)
        ld   bc,(COLS)
        ldir                 ;copy a row of " " to j$()
        ld   (ADDRjS),de     ;LET j$(snf TO )=l$+o$

        exx                  ;switch to alternate
        ld   d,(ix+8)        ;sg = w
FOR_w2:
        ld   a,d
        exx                  ;switch to primary

        ld   hl,(VAL_va)
        ld   b,0
        ld   c,a
        add  hl,bc
        ld   a,(hl)          ;attr=PEEK (va+w)
        or   a
        jp   z,EditRow       ;preserve space squares
        and  %00000111
        cp   3
        jp   nc,EditRow      ;or INK 3,4,5,6,7 squares

        cp   2             ;*
        jp   nz,NEXT_w2    ;*

        ;a rock will be destroyed, so remove it from the FALLING table
        ld   de,64240-22528;!offset attribute pointer into Table2
        add  hl,de         ;*
        ld   b,0           ;*
        ld   c,(hl)        ;*;get Table1 offset in Table2
        ld   (hl),$FF      ;*
        ld   hl,64000      ;!;Table1 start address
        add  hl,bc         ;*
        ld   (hl),0        ;*
        inc  hl            ;*
        ld   (hl),0        ;*;reset display file address in Table1
        jp   NEXT_w2       ;*

EditRow:                     ;IF attr-INT (attr/8)*8>2 THEN
        inc  (ix+15)         ;s=s+1
        ld   de,(ADDRdS)     ;update preserved item attributes
        ld   a,l
        ld   (de),a
        inc  de
        ld   a,h
        ld   (de),a
        inc  de
        ld   a,(hl)
        ld   (de),a
        inc  de
        ld   (ADDRdS),de     ;d$(s)=[lo(va+w)+hi(va+w)]+CHR$ attr:

        exx                  ;switch to alternate
        push bc
        push de
        exx                  ;switch to primary
        pop  de
        pop  bc
        ld   c,b             ;C =B' =v
        ld   b,d             ;B =D' =w
        push bc            ;*
        push de
        call Scrn_CB       ;*;A =SCREEN$ (C,B)
        pop  de

        ex   af,af'
        ld   a,d
        sub  (ix+8)          ;A =w-sg
        ld   e,a
        ld   d,0
        ld   hl,(ADDRjSo)
        add  hl,de
        ex   af,af'          ;save CHR$ at row,col in j$()
        ld   (hl),a          ;j$(sf+w)=SCREEN$ (v,w)
        ld   hl,(ADDRnSo)
        add  hl,de           ;place " " at row,col in n$()
        ld   (hl)," "        ;n$(sf+w)=" "
        pop  bc            ;*

NEXT_w2:
        exx                  ;switch to alternate
        inc  d
        ld   a,e
        cp   d
        jp   nc,FOR_w2

        inc  b
        ld   a,c
        cp   b
        jp   nc,FOR_v2

        exx                  ;switch to primary
        ld   bc,1
        ld   de,VAR_s
        call FindVariable
        ld   de,VAL_d
        ex   de,hl
        ld   bc,5
        ldir
        ei
        ret

Scrn_BC:; S_SCRN$_S expects row in C, col in B
        ld   a,b
        ld   b,c
        ld   c,a
Scrn_CB:
        call $2538           ;S_SCRN$_S+3
        ld   hl,(23653)
        ld   bc,5
        and  a
        sbc  hl,bc
        ld   (23653),hl      ;remove entry from stack
        inc  hl
        ld   e,(hl)
        inc  hl
        ld   d,(hl)
        ld   a,(de)          ;A =SCREEN$ (v,w)
        ret                ;*

Get_s4:
        push de
        push bc
        call FindVariable
        call $33b4           ;STACK_NUM
        call $2dd5           ;FP_TO_A
        pop  bc
        pop  de
        inc  de
        inc  de
        inc  de
        ld   (de),a
        inc  de
        ret

VAR_su: defm "su:"
VAL_su: defb 0               ;(ix+00)
VAR_sv: defm "sv:"
VAL_sv: defb 0               ;(ix+04)
VAR_sg: defm "sg:"
VAL_sg: defb 0               ;(ix+08)
VAR_sh: defm "sh:"
VAL_sh: defb 0               ;(ix+12)
VAL_d:  defb 0,0,$ff,0,0     ;(ix+15) (3rd byte)

VAL_va: defw 0000
COLS:   defw 0000            ;hi-byte is always 00
VAL_lS: defb $16,0,0
VAR_qS: defm "q$:"
ADDRqS: defw 0000
VAR_nS: defm "n$():"
ADDRnS: defw 0000
ADDRnSo:defw 0000
VAR_oS: defm "o$:"
ADDRoS: defw 0000
VAR_jS: defm "j$():"
ADDRjS: defw 0000
ADDRjSo:defw 0000

VAR_s:  defm "s:"
VAR_dS: defm "d$():"
ADDRdS: defw 0000



RobotData:   defw 0000       ;robot level data start address
;m$(8,10) row = m$(j)=row step, col step,
;                    +$16, current row, current col,
;                    +$11, paper, $10, ink, CHR$ code
ROBOTS:
        call FindDigger
        ld   bc,8
        ld   de,Bdollar
        call FindVariable
        ld   a,6
        inc  hl
        cp   (hl)            ;check if Digger is on path
        jp   nz,NotOnPath
        ld   bc,(P_coords)
        call GetAttrAddr
        ld   (hl),6          ;set Digger square to path attribute
NotOnPath:
        ld   bc,8
        ld   de,VAR_mS
        call FindVariable
        ld   bc,20
        add  hl,bc           ;start on 3rd row of m$()
        ld   (ADDRmS),hl
        ld   de,6             ;maximum # of robots allowed

NextRobot:
        push hl
        pop  ix
        ld   b,(ix+3)
        ld   c,(ix+4)
        ld   (O_coords),bc   ;=old coordinates
        ld   (N_coords),bc   ;=new coordinates, in case unable to move
        ld   a,b
        or   c
        ei
        ret  z               ;if no more robots to move

        di
        push de
        call CheckMove
        jp   z,MakeMove      ;continue moving in same direction


        ;can't continue moving in same direction, check alternative moves
NextMove:
        xor  a
        or   (ix+0)
        jp   z,DoRow

DoCol:  ld   a,(ix+0)
        ex   af,af'
        ld   (ix+0),0
        ld   (ix+1),1
        call CheckMove
        jp   z,MakeMove
        ld   (ix+1),$ff
        call CheckMove
        jp   z,MakeMove
        ld   (ix+1),0
        ex   af,af'
        neg
        ld   (ix+0),a
        call CheckMove
        jp   z,MakeMove
        ld   a,6
        jp   CheckLast

DoRow:  ld   a,(ix+1)
        ex   af,af'
        ld   (ix+1),0
        ld   (ix+0),1
        call CheckMove
        jp   z,MakeMove
        ld   (ix+0),$ff
        call CheckMove
        jp   z,MakeMove
        ld   (ix+0),0
        ex   af,af'
        neg
        ld   (ix+1),a
        call CheckMove
        jp   z,MakeMove
        jp   CheckLast

MakeMove:
        push af
        ld   bc,(O_coords)
        ld   a,b
        ld   (Path+1),a
        ld   a,c
        ld   (Path+2),a
        ld   de,Path
        ld   bc,8
        call $203c           ;PR_STRING, print path at old position

        ld   bc,(N_coords)
        ld   (ix+3),b
        ld   (ix+4),c
        push ix
        pop  de
        inc  de
        inc  de
        ld   bc,8
        call $203c           ;PR_STRING, print robot at new position
        pop  af

CheckLast:
        ei
        pop  bc
        or   a               ;return with BC=row count
        ret  z               ;if moved off path to empty space
        ld   d,b
        ld   e,c
        ld   hl,(P_coords)
        ld   bc,(N_coords)
        and  a
        sbc  hl,bc
        ld   b,255           ;make BC big, to distinguish from space exit
        ret  z               ;if caught Digger
        push ix
        pop  hl
        ld   bc,10
        add  hl,bc
        dec  e
        jp   nz,NextRobot
        ld   c,0
        ret

CheckMove:
        ld   bc,(O_coords)
        ld   a,b
        add  a,(ix+0)
        ld   b,a
        ld   a,c
        add  a,(ix+1)
        ld   c,a
        ld   (N_coords),bc
        call GetAttrAddr
        ld   a,6
        cp   (hl)            ;check for path
        ret  z
        xor  a
        cp   (hl)            ;check for space
        ret

Path:   defb $16,0,0,$11,0,$10,6,"@"

Bdollar:  defm "b$():"

VAR_mS: defm "m$():"
ADDRmS: defw 0000



;1018 FOR j=k1 TO kL:
;       PRINT a$(j); BRIGHT sg; INK su;y$;: RANDOMIZE FN p(23684)-k1:
;       POKE va+v,PEEK 23670: POKE va+v+k1,PEEK 23671:
;       POKE FN v(CODE a$(j,k2),CODE a$(j,k3))+40712,v: LET v=v+k2:
;     NEXT j: RANDOMIZE: RETURN

Adollar:  defm "a$():"
String:   defb $16,$00,$00, $13,$00, $10,$00, $00

LOADT1_2: ;load rock & diamond positions into Tables 1 & 2
        ld   bc,8
        ld   de,Adollar
        call FindVariable
        ld   ix,String
        ld   a,(23679)
        ld   (ix+7),a        ;CHR$ to print (rock or diamond)
        ld   a,(23695)
        ld   (ix+6),a
        res  6,(ix+6)        ;set INK
        and  %01000000
        rlca
        rlca
        ld   (ix+4),a        ;set BRIGHT
        ld   b,50
LOADT1_2a:
        push bc              ;BC=row counter
        ld   de,String
        ld   bc,3
        ldir
        push hl              ;HL=a$() pointer
        ld   de,String
        ld   c,8
        call $203C           ;PR_STRING
        ld   b,(ix+1)
        ld   c,(ix+2)
        call RowColBCDispHL  ;HL=display address for row,col in BC
        ld   de,(23680)      ;DE=position in Table1 (starts at 64000 or 64100)
        ex   de,hl
        push hl              ;save Table1 address
        ld   (hl),e
        inc  hl
        ld   (hl),d          ;store display address  in Table1
        inc  hl
        ld   (23680),hl
        call GetAttrAddr     ;HL=22528 + BC=row*32 + DE=col = attribute address
        ld   hl,64240      ;!
        add  hl,bc
        add  hl,de           ;HL=64240 + BC=row*32 + DE=col = Table2 address
        ex   de,hl
        pop  hl              ;get Table1 address ...
        ld   bc,64000      ;!
        sbc  hl,bc           ;... - base address = offset
        ex   de,hl
        ld   (hl),e          ;store Table1 offset in Table2
        pop  hl
        pop  bc
        djnz LOADT1_2a
        ret



SCAN_USR ; scan for a USR call in a BASIC line
        ld   hl,(23563)      ;(DEFADD)
        inc  hl
        inc  hl
        call $33b4           ;STACK_NUM
        call $2da2           ;FP_TO_BC = start address
        ld   h,b
        ld   l,c
        ld   bc,5
GetByte:
        ld   a,(hl)          ;(SCAN_USR+18) = token code
        cp   192             ;192=USR, 215=BEEP, 228=DATA
        jp   nz,CHK014
        ld   b,h
        ld   c,l
        ret                  ;return match address
CHK014: cp   14
        jp   nz,CHK013
        add  hl,bc           ;skip FP marker
        jp   NxtByte
CHK013: cp   13
        jp   z,$1bec         ;"N - Statement lost"
NxtByte:inc  hl
        jp   GetByte



UNSTABLE:
        call FindDigger
        call GetAttrAddr
        push hl
        pop  ix
        ld   hl,HereD
        ld   de,BFdata
        ld   b,8
LOOP1:
        push bc
        and  a
        call CheckBlank      ;check for empty column
        call CheckBlank      ;  next to Digger
        jp   c,NotEmpty
        xor  a               ;reset Zero
        call CheckType       ;check for unstable column
        call CheckType       ;  next to empty column
        jp   nz,NEXT1
        pop  bc
        ret                  ;return non-zero if matched
NotEmpty:
        inc  de
        inc  de
NEXT1:
        pop  bc
        djnz LOOP1

        ld   de,BFdata
        ld   b,8
LOOP2:
        push bc
        and  a
        call CheckBlank      ;check for empty square next to Digger
        jp   c,NotBlank
        xor  a               ;reset Zero
        call CheckType       ;check for falling object above that square
        jp   nz,NEXT2
        pop  bc
        ret                  ;return non-zero if matched
NotBlank:
        inc  de
NEXT2:
        inc  de
        inc  de
        pop  bc
        djnz LOOP2

        ld   c,b             ;return zero if no match
        ret

CheckBlank:
        ld   a,(de)
        inc  de
        ret  c
        ld   (OFF1+2),a
        ld   a,7
OFF1:   cp   (ix+0)
        ret

CheckType:
        ld   a,(de)
        inc  de
        ret  nz
        ld   (OFF2+2),a
OFF2:   ld   a,(ix+0)
        ld   (hl),a
        ex   de,hl
        call CheckMoving
        ex   de,hl
        ret

BFdata: defb -32,-64, -33,-65
        defb  32, 64,  33, 65
        defb -32,-64, -31,-63
        defb  32, 64,  31, 63
BSdata: defb  -1,-33,  -2,-34
        defb  -1, 31,  -2, 30
        defb   1,-31,   2,-30
        defb   1, 33,   2, 34


PLAY_MODE:
CODE_FINISH: